# coding: utf-8

"""
    Project Service API

    Project Service exposes a REST API, providing access to operations with projects Example: 1. `$orderby` - Sorting criteria in the format: property (asc | desc). Default sort order is ascending.     ```/project-service/api/projects?$orderby=name%20desc``` 2. `$top` -  limits the requested number of resources.     ```/project-service/api/projects?$top=10``` 3. `$skip` -  client can skip a given number of resources.      ```/project-service/api/projects?$skip=2``` 4. `$top` & `$skip` - used in conjunction helps in pagination of resources        ```/project-service/api/projects?$top=10&$skip=2``` 5. `$filter` -  returns a subset of resources that satisfy the given predicate expression.     ```/project-service/api/projects?$filter=startswith(name, 'Test')```  # noqa: E501

    OpenAPI spec version: 2020-08-10
    Contact: sales@vmware.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from idem_vra.client.vra_rbac_lib.api_client import ApiClient


class PermissionApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_all_permissions(self, **kwargs):  # noqa: E501
        """Get all permissions  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_all_permissions(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param bool exclude_organization_scoped_only: Exclude organization scoped only permission. When the flag is true, it will not include the permissions which are applicable only to organization
        :param bool exclude_project_scoped: Exclude Project scoped Permissions. When the flag is true, it will not include the project scoped permissions. 
        :param str api_version:
        :return: InlineResponse2004
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_all_permissions_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_all_permissions_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_all_permissions_with_http_info(self, **kwargs):  # noqa: E501
        """Get all permissions  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_all_permissions_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param bool exclude_organization_scoped_only: Exclude organization scoped only permission. When the flag is true, it will not include the permissions which are applicable only to organization
        :param bool exclude_project_scoped: Exclude Project scoped Permissions. When the flag is true, it will not include the project scoped permissions. 
        :param str api_version:
        :return: InlineResponse2004
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['exclude_organization_scoped_only', 'exclude_project_scoped', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_all_permissions" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'exclude_organization_scoped_only' in params:
            query_params.append(('excludeOrganizationScopedOnly', params['exclude_organization_scoped_only']))  # noqa: E501
        if 'exclude_project_scoped' in params:
            query_params.append(('excludeProjectScoped', params['exclude_project_scoped']))  # noqa: E501
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/rbac-service/api/permissions', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2004',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_permission(self, id, **kwargs):  # noqa: E501
        """Retrieve a permission by id  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_permission(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str id: (required)
        :param str api_version:
        :return: InlineResponse2003
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_permission_with_http_info(id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_permission_with_http_info(id, **kwargs)  # noqa: E501
            return data

    def get_permission_with_http_info(self, id, **kwargs):  # noqa: E501
        """Retrieve a permission by id  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_permission_with_http_info(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str id: (required)
        :param str api_version:
        :return: InlineResponse2003
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_permission" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `get_permission`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501

        query_params = []
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/rbac-service/api/permissions/{id}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2003',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
